/// =============== Klassen-Definition: VEKTOR  ==========================================
// VEKTOR-Klasse fuer Vektor-Operationen vom Typ double
// ======================================================================================
// Copyright: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Erkrath/Darmstadt
// experimentelles Lehr- und Studienprogramm - kommerzielle Nutzung nicht gestattet
// Der Autor bernimmt keine Haftung fr Unvollstndigkeiten und Maengel der Algorithmen!
// Version:  6/1995
// Compiler: C++
// ================ Include-Files =======================================================
#include "pch.h"
#include "framework.h"
#include "MATRIXclass.h"
// -------------------
// #include "Vektor.h"
// #include "Matrix.h"
// ============================================================================
// public -> Oeffentliche Mitgliedsfunktionen
// ============================================================================
//
// Konstruktor -> VEKTOR vek(ni)
// =============================
// ni: Dimension des 1D-Vektors, interne Speicherung -> vek(1,ni)
// --------------------------------------------------------------
VEKTOR::VEKTOR(int ni) : MATRIX(1,ni)
{
//*** std::cerr<<"VEKTOR::Konstruktor: neuen Vektor erzeugen"<<'\n';
};//---------------------------------------------------------------------------
//
// Konstruktor -> VEKTOR vek(C_array,ni)
// ====================================
// C_array vorinitialisiert mittels Initialisierungsliste C_feld [] = { ... }
// ni: Dimension des 1D-Vektors, interne Speicherung -> vek(1,ni)
// --------------------------------------------------------------
VEKTOR::VEKTOR(double* C_array,int ni) : MATRIX(C_array,1,ni)
{
//*** std::cerr<<"VEKTOR::Konstruktor: neuen Vektor erzeugen"<<'\n';
};//---------------------------------------------------------------------------
//
// Destruktor -> delete &vek
// =========================
VEKTOR::~VEKTOR(void)
{
//*** std::cerr<<"VEKTOR::Destruktor: Loeschen von VEKTOR"<<'\n';
};//---------------------------------------------------------------------------
//
// Alle Vektor-Elemente belegen -> vek =zahl
// =========================================
// Hier nochmal, weil der Zuweisungsoperator  = nicht vererbt werden kann !!!
// --------------------------------------------------------------------------
VEKTOR &VEKTOR::operator = (double zahl)
{
this->zuweisen(zahl,0);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *this;
};//---------------------------------------------------------------------------
//
// Matrix zuweisen -> vek =mat (nur Matrizeninhalt kopieren)
// ===========================
// Hier nochmal, weil der Zuweisungsoperator  = nicht vererbt werden kann !!!
// --------------------------------------------------------------------------
VEKTOR &VEKTOR::operator  = (MATRIZEN &mat)
{
this->zuweisen(mat,0);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
mat.temporaere_matrix_loeschen();
//
return *this;
};//---------------------------------------------------------------------------
//
// Multiplikation mit Skalar -> vek*zahl
// =====================================
MATRIZEN &VEKTOR::operator * (double zahl)
{
//*** std::cerr<<"VEKTOR:: vek*zahl"<<'\n';
//
return this->MATRIZEN::operator *(zahl);
};//--------------------------------------------------------------------
//
// Skalarprodukt -> vek1*vek2 -> zahl = vek1(s) * vek2(s)
// ============================================================================
double VEKTOR::operator * (VEKTOR &vek2)
{
//*** std::cerr<<"VEKTOR:: vek1 * vek2"<<'\n';
int dim;
double r;
dim=dimmax;
if(dim > vek2.dimmax) dim=vek2.dimmax;
r=skalarprodukt(this->matrix,1,vek2.matrix,1,dim);
//
//*** std::cerr<<"VEKTOR: r = vek1(s) * vek2(s) = "<<r<<'\n';
//
return r;
};//------------------------------------------------------------------------
//
// Matrizenmultiplikation -> vek*mat -> c(k,l)=vek(s) * mat(k,s,l)
// =================================
MATRIZEN &VEKTOR::operator * (MATRIZEN &mat)
{
//*** std::cerr<<"VEKTOR:: vek * mat"<<'\n';
//
return this->MATRIZEN::operator * (mat);
};//--------------------------------------------------------------------------
// WERT suchen
// ===========
// Argumente:
// knonr: Wert, nach dem gesucht wird
// n   : Laenge des Vektors
//     : -1 Laenge automatisch ermitteln 
// d   : Schrittweite, mit der der Vektor durchsucht wird
// Funktionsergebnis: relativer Anfangsindex (0,1,..), bei dem knonr gefunden
//                    -1 knonr wurde nicht gefunden
int VEKTOR::wert_suchen(double knonr,int n,int d)
{
// Dimension von knotennummern ermitteln
int dim,ni,nj,nk,nl;
dim=n;
if(n < 0) dim=this->dimension_ermitteln(ni,nj,nk,nl);
//
int wert_intern=-1;
//
for(int i=0; i<dim/d; i+=d)
{
if(this->element(i) == knonr) {wert_intern=i; break;};
};
//
return wert_intern;
};
// ============================================================================
